VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "File Icons - Extracting Icons From Files"
   ClientHeight    =   4590
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   306
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox picIcon 
      Height          =   1095
      Left            =   120
      ScaleHeight     =   69
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   293
      TabIndex        =   4
      Top             =   2400
      Width           =   4455
   End
   Begin VB.ComboBox cboIcons 
      Height          =   315
      Left            =   2400
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   2040
      Width           =   2175
   End
   Begin VB.FileListBox fil 
      Height          =   1845
      Left            =   2400
      Pattern         =   "*.exe;*.dll;*.ico"
      TabIndex        =   2
      Top             =   120
      Width           =   2175
   End
   Begin VB.DriveListBox drv 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   2040
      Width           =   2175
   End
   Begin VB.DirListBox dir 
      Height          =   1890
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2175
   End
   Begin VB.Label lblAbout 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "vbmonster@hotmail.com"
      ForeColor       =   &H80000008&
      Height          =   195
      Index           =   2
      Left            =   2805
      TabIndex        =   7
      Top             =   4080
      Width           =   1770
   End
   Begin VB.Label lblAbout 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "http://vbmonster.cjb.net/"
      ForeColor       =   &H80000008&
      Height          =   195
      Index           =   1
      Left            =   2700
      TabIndex        =   6
      Top             =   3840
      Width           =   1875
   End
   Begin VB.Label lblAbout 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "This example was brought to you by Visual Basic Monster"
      ForeColor       =   &H80000008&
      Height          =   195
      Index           =   0
      Left            =   480
      TabIndex        =   5
      Top             =   3600
      Width           =   4095
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Type ICONINFO
    fIcon As Long
    xHotspot As Long
    yHotspot As Long
    hbmMask As Long
    hbmColor As Long
End Type
Private Declare Function GetIconInfo Lib "user32" (ByVal hIcon As Long, piconinfo As ICONINFO) As Long
Private Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long) As Long
Dim sFileName As String
Private Sub cboIcons_Click()
Dim hIcon As Long, infIcon As ICONINFO
Dim nX As Integer, nY As Integer
'get the icon handle by extracting it from the selected file
hIcon = ExtractIcon(0, sFileName, cboIcons.ListIndex)
GetIconInfo hIcon, infIcon              'get some information
picIcon.Cls                             'clear the picturebox to erase the previous icon
nX = (picIcon.ScaleWidth \ 2) - infIcon.xHotspot      'center the X value
nY = (picIcon.ScaleHeight \ 2) - infIcon.yHotspot     'center the Y value
DrawIcon picIcon.hdc, nX, nY, hIcon     'display icon
DestroyIcon hIcon                       'free system resourses
End Sub

Private Sub dir_Change()
fil.Path = dir.Path
End Sub
Private Sub drv_Change()
On Error GoTo DriveError
dir.Path = drv.Drive
Exit Sub
DriveError:
    'thanks to Pieter <yellow@zeelandnet.nl> for pointing out that error!
    drv.Drive = dir.Path
End Sub
Private Sub fil_Click()
Dim I As Long
sFileName = fil.Path + "\" + fil.filename
cboIcons.Clear
'See how many icons the file has and
'add them to the combobox
For I = 0 To ExtractIcon(0, sFileName, -1) - 1
    cboIcons.AddItem "Icon #" + CStr(I)
Next I
'show how many icons we've got
cboIcons.ListIndex = cboIcons.NewIndex
End Sub
